;=========================================;
;         INCLUDE for ENGINE I2C	  ;
;-----------------------------------------;
;File Name :	ENG_I2C.INC		  ;	
;Date      :    04/01/03		  ;
;=========================================;
		DSEG
		ORG	0063H
AddressI2C:	DS	1	;Address for I2C
BufferIn0:	DS	1	;Buffer In for I2C Data 0
BufferIn1:	DS	1	;Buffer In for I2C Data 1	
;BufferIn2:	DS	1	;Buffer In for I2C Data 2
;BufferIn3:	DS	1	;Buffer In for I2C Data 3
;BufferIn4:	DS	1	;Buffer In for I2C Data 4 
;BufferIn5:	DS	1	;Buffer In for I2C Data 5	
;BufferIn6:	DS	1	;Buffer In for I2C Data 6
;BufferIn7:	DS	1	;Buffer In for I2C Data 7
BufferOut0:	DS	1	; Buffer Out for I2C Command Out
BufferOut1:	DS	1	; Buffer Out for I2C Data 0
BufferOut2:	DS	1	; Buffer Out for I2C Data 1
BufferOut3:	DS	1	; Buffer Out for I2C Data 2
BufferOut4:	DS	1	; Buffer Out for I2C Data 3
;BufferOut5:	DS	1	; Buffer Out for I2C Data 4
;BufferOut6:	DS	1	; Buffer Out for I2C Data 5
;BufferOut7:	DS	1	; Buffer Out for I2C Data 6

SCL		BIT	P1.6
SDA		BIT	P1.7

Flag		DATA	0021H
FACK		BIT	Flag.0
FLB		BIT	Flag.1

		CSEG
;-----------------------------------------
;Start Condition Routine
;Input  : none
;Output : none
;-----------------------------------------
StartCon:	CLR	SCL			;SCL Low
		SETB	SDA			;SDA High
		ACALL 	DelayXus
		SETB	SCL			;SCL High	
		ACALL 	DelayXus
		CLR	SDA			;SDA ~|_ when SCL High 
		ACALL 	DelayXus
		RET				

;-----------------------------------------
;Stop Condition Routine
;Input  : none
;Output : none
;----------------------------------------- 
StopCon:	CLR	SCL			;SCL Low------------------\
		CLR	SDA 			;(2) SDA Low		  |
		ACALL 	DelayXus		;			  |
		ACALL	DelayXus		;			  |
		SETB	SCL			;SCL High		  |-STOP
		ACALL 	DelayXus		;			  |
		SETB	SDA			;(2) SDA _|~ when SCL High|
		ACALL 	DelayXus		;			  |
		RET				;(1) ---------------------/

;-----------------------------------------
;Delay Routine For I2C
;Input  : none
;Output : none
;-----------------------------------------
DelayXus:	
		PUSH	07H
		MOV	R7,#08H
		DJNZ	R7,$
		POP	07H
		RET

;-----------------------------------------
;Master Transmitter Routine
;Input  : ACC <- Address/Command/Data byte
;Output : none
;----------------------------------------- 
Mtx:		PUSH	07H
		PUSH	ACC
		MOV	R7,#8
NexBit:		CLR	SCL			;SCL Low -------------\
		RLC	A 			;(1) Data MSB first   |
		JNC	TxL 			;(2) Data Bit Low     |	
TxH:		SETB	SDA 			;(2) SDA High	      |-1 CLK
		AJMP	Clock 			;(2)  		      |
TxL:		CLR	SDA 			;(2) SDA Low	      |
Clock:		ACALL 	DelayXuS		;		      |
		SETB	SCL			;SCL High             |
		ACALL	DelayXuS		; 		      |
		DJNZ	R7,NexBit		;(2) -----------------/ 				
AckPhaseClk:	CLR	SCL			;SCL Low -------------\
		SETB	SDA			;(2) release SDA high  |
		ACALL	DelayXuS		; 		       |
		SETB	SCL			;SCL High              |-CLK
		ACALL	DelayXuS		; 	 	       |
		JNB	SDA,Ack			;(3) Chck SDA ACK/NACK | ACK
Nack:		CLR	FACK			;(2)		       |
		AJMP	EOMtx			;(2)   		       |	
Ack:		SETB	FACK			;(2)		       |	 
EOMTx:		POP	ACC			;(2)		       |	
		POP	07H			;(2)		       |		       		
		RET				;(1) ------------------/

;-----------------------------------------
;Master Receiver Routine
;Input  : FLB <- 1/0	
;Output : ACC --> Data byte
;----------------------------------------- 
MRx:		PUSH	PSW
		PUSH	07H
RdData:		MOV	R7,#8
		CLR	C
NextBit:	ACALL	DelayXus
		CLR	SCL			;SCL Low --------\	
		SETB	SDA			;(2)For input	 |
		ACALL	DelayXus		;		 |
		SETB	SCL			;SCL High	 |
		JB	SDA,HiBit		;(3) Chk SDA H/L |
LoBit:		CLR	C			;(1)		 |-1 CLK
		AJMP	SaveBit			;(2)		 |
HiBit:		SETB	C			;(1)		 |
SaveBit:	RLC	A			;(1)		 |
		DJNZ	R7,NextBit		;(2) ------------/

AckPhsClk:	ACALL	DelayXus
		CLR	SCL			;SCL Low ----\	
		JB	FLB,NAckd		;(3)	     |	
Ackd:		CLR	SDA			;(2)	     |		
		AJMP	ClkHigh			;(2)  	     |-ACK Related
NAckd:		SETB	SDA			;(2)	     | CLK
ClkHigh:	ACALL	DelayXus		;	     |
		SETB	SCL			;SCL High    |	
		ACALL	DelayXus		; -----------/	
EOMRx:		POP	07H			;(2)
		POP	PSW			;(2)
		RET				;(1)