;Contoh Program pengaturan kecepatan motor 
;dengan FUZZY, menggunakan DT-51 Petra Fuzz

	$MOD51
	
	CSEG AT 4000H
	AJMP start

	DSEG AT 6BH
data1:	DS	2
	
	$INCLUDE(dataf.ASM)
	$INCLUDE(ENG_I2C1.INC)
	$INCLUDE(DCMOTOR1.INC)
	
fuzzify		EQU 900h
current_ins	EQU 08h
cog_out		EQU 0dh

start:	mov sp,#06DH
	acall serial			;Inisialisasi Serial
	mov addressI2C,#11101110b
	mov dccontrol,#01000010b
	mov gatetime,#20h
	mov pwm1,#0FFH			;set kecepatan awal = 0 RPM
	acall dcinit			;Inisialisasi SPC DC Motor
	mov r6,#0
	mov r7,#0
ulangi1:	
	acall terima			;Ambil Data serial
	cjne a,#'J',ulangi1
	acall terima			;Ambil Nilai SP Low Byte Dari PC
	mov data1,a
ulangi2:
	acall terima
	cjne a,#'K',ulangi2
	acall terima			;Ambil Nilai SP High Byte Dari PC
	mov data1+1,a

ulang:	acall baca_rpm1			
	acall err
	acall derr
	mov a,r4			;Simpan nilai error(n) untuk dijadikan error(n-1)
	mov r6,a
	mov a,r5
	mov r7,a
	mov current_ins+2,#0		;Masukkan crisp input 3 = 0
	mov current_ins+3,#0		;Masukkan crisp input 4 = 0
	mov current_ins+4,#0		;Masukkan crisp input 5 = 0
	lcall fuzzify			;Panggil prosedur fuzzify
	acall ambil_data
	ajmp ulang

baca_rpm1:	
	acall delay1s
	acall getinput1			;Ambil data dari motor1
	mov r1,#4

	mov a,inputl1			;Masukkan data ke Accumulator
	mov b,#60			;|
	mul ab				;|
	mov r2,a			;|
	mov r3,b			;|
ulang4:	clr c				;|
	mov a,r3			;}Proses perhitungan RPM
	rrc a				;|
	mov r3,a			;|RPM = Banyaknya Clock
	mov a,r2			;|	---------------  x 60 dtk
	rrc a				;|	Jumlah lubang
	mov r2,a			;|    	
	djnz r1,ulang4			;|    = Inputl1
					;|      ------- x 60
					;|         16
	mov a,r2
	acall kirim			;Kirim Nilai PV LSB
	mov a,r3
	acall kirim			;Kirim Nilai PV MSB
	ret

;----------------------------
;  Proses pemasukan error
;  error = SP - PV
;----------------------------
err:	
	mov dpl,r2
	mov dph,r3
	mov a,dpl			;Nilai PV LSB
	mov b,dph			;Nilai PV MSB
	mov r0,data1			;Nilai SP LSB
	mov r1,data1+1			;Nilai SP MSB
	clr psw.6			;memberi tandan bahwa memasuki proses error
	acall count
	mov current_ins,a		;Masukkan Nilai Crisp Input 1
	ret

;---------------------------------
;  Proses pemasukan derror
;  derror = error(n) - error(n-1)
;---------------------------------
derr:	mov a,r4
	mov r0,a
	mov a,r5
	mov r1,a
	mov a,r6
	mov b,r7
	setb psw.6			;memberi tanda bahwa memasuki proses derror
	acall count
	mov current_ins+1,a		;memasukkan nilai crisp input 2
	ret


;-----------------------------
; Proses Normalisasi crisp input
;-----------------------------
count:	mov dpl,a			;PV LSB	
	mov dph,b			;PV MSB
	mov a,dph
	cjne a,#0,bknol			;check apa nilai PV negatif 16 Bit
	mov a,dpl
	cjne a,#0,bknol
	ajmp nol

bknol:	mov a,dpl			
	clr c				
	cpl a				;inverse-kan nilai accumulator			
	add a,#1			;tambahkan dengan 1
	mov dpl,a			;pindahkan accumulator ke DPL
	mov a,dph			;masukkan nilai dph ke accumulator
	cpl a				
	addc a,#0			;tambahkan nilai accumulator dengan nilai carry flag
	mov dph,a			;pindahkan nilai accumulator ke dph

nol:	mov r3,dph
	mov r2,dpl
	clr c
	mov dpl,r0			;SP Low Byte
	mov dph,r1			;SP High Byte
	mov a,dpl
	add a,r2
	mov dpl,a
	mov a,dph
	addc a,r3
	mov dph,a
	jnb psw.6,terus3		;apakah dari proses perhitungan error ?
	mov r4,dpl			;save error(n) low byte
	mov r5,dph			;save error(n) high byte
terus3:	clr c


;------------------------ 
; Proses normalisasi	
; dari crisp output
; menjadi fuzzy input
;------------------------
	mov r0,dph	
	mov a,dph
	anl a,#0F0H			;ambil 4 bit teratas dari accumulator
	cjne a,#0F0H,pos		;check apakah nilainya negatif
	mov r1,#1
	mov a,dpl
	cpl a
	inc a
	mov dpl,a
	mov a,dph
	cpl a
	addc a,#0
	mov dph,a
	ajmp negg

pos:	mov a,r0
	mov dph,a
	mov r1,#0

negg:	mov a,dph
	cjne a,#1,nk			;check apakah inputnya 16 Bit
	mov r0,#2

gesert:	clr c				
	mov a,dph			
	rrc a				
	mov dph,a			
	mov a,dpl			
	rrc a				
	mov dpl,a			
	djnz r0,gesert			
	ajmp habis			
					
nk:	mov a,dpl			
	mov b,#4			
	div ab				
	mov dpl,a			

habis:	cjne r1,#0,neg1			;check apa inputnya negatif
	mov a,#128			
	add a,dpl			
	ajmp habis1			
					
neg1:	mov a,#127			
	subb a,dpl			

habis1:	clr c
	ret


;-------------------------------- 
; Proses Denormalisasi
; dari fuzzy output
; menjadi crisp output
;--------------------------------
ambil_data:
	mov a,cog_out				;Ambil data dari cog_out 
	clr c
	cjne a,#193,terus			;check apakah input > 193

terus:	jnc lb					;jika lebih besar maka loncat ke label lb
	clr c
	subb a,#128		
	jnc kurang
	cpl a
	add a,#1
	mov r0,a
	mov a,pwm1				;ambil nilai pwm1 sekarang
	add a,r0
	jnc terus1				;check apakah nilai ACC lebih besar dari 255
	mov a,#255

terus1:	sjmp habis2

lb:	clr c
	subb a,#127

kurang:	mov r0,a
	mov a,pwm1				;ambil nilai pwm1 sekarang
	subb a,r0
	jnc terus2				;check apakah nilai ACC lebih kecil dari 0
	mov a,#0

terus2:	sjmp habis2

habis2:	mov pwm1,a				;masukkan nilai accumulator ke pwm1
	lcall setpwm1				;panggil procedure untuk memasukkan ke pmw motor 1
	ret


;------------------------
;Prosedur delay 1 detik
;------------------------
delay1s:
	mov r0,#7
ulang2:	mov r1,#0FFH	
ulang1:	mov r2,#0FFH
	djnz r2,$
	djnz r1,ulang1
	djnz r0,ulang2
	ret


;-----------------------------
;  Bagian komunikasi Serial
;-----------------------------
kirim:	mov sbuf,a
	jnb ti,$
	clr ti
	ret

terima:	jnb ri,$
	clr ri
	mov a,sbuf
	ret

serial:	mov pcon,#0
	mov scon,#01010000b
	mov tmod,#00100000b
	mov th1,#0fdh
	setb tr1
	ret

	end